/**



**/

#include <irrlicht.h>
#include <iostream>


using namespace irr;


using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;


#ifdef _IRR_WINDOWS_
#pragma comment(lib, "Irrlicht.lib")
#pragma comment(linker, "/subsystem:windows /ENTRY:mainCRTStartup")
#endif


static const s32 SCROLLBAR_MAXVALUE = 10000;

//EJA_NUMBER_OF_AXES
//+ 1
static const int POV_ROW = EJA_NUMBER_OF_AXES ;

enum {
JOYSTICK_LIST,
EVENT_LOGGER,
JOYSTICK_BUTTONS,
THRESHOLD_SELECTOR,
DEADZONE_SELECTOR,
THRESHOLD_TEXT,
JOYSTICKDESCRIPTOR_TEXT,
AXES_TABLE
};

/*
// TODO :
-individual axis Threshold
*/
struct MyEventReciever : public IEventReceiver
{
    IrrlichtDevice* Device;
    IGUIListBox* EventList;           //!< to log events
    IJoystick* CurrentJoystick;     //!< currentJoystick

    IGUIComboBox * JoystickList;
    ILogger* Logger;
    IGUIScrollBar * ThresholdSelector;
    IGUIScrollBar * GlobalDeadzoneSelector;
    IGUITable *AxesTable;
    IGUIStaticText *CapabilitiesText;
    IGUIStaticText *ThresholdText;
    IGUIStaticText *GlobalDeadzoneText;
    IGUIStaticText *JoystickDescriptor;


    typedef core::map< IJoystick*,u32> TJoystickMap;
    TJoystickMap Joysticks;    //!< associate joystick with combobox id


    MyEventReciever(IrrlichtDevice* device) :
                        Device(device),EventList(0),
                        CurrentJoystick(0),JoystickList(0),
                        AxesTable(0),
                        Logger(0),
                        ThresholdSelector(0),ThresholdText(0),
                        GlobalDeadzoneSelector(0),GlobalDeadzoneText(0),
                        JoystickDescriptor(0)
    {
        IGUIEnvironment* guienv     = device->getGUIEnvironment();

        Logger = device->getLogger();


        /////////////////////////////////////////////////////
        ///// Add combobox to choose between available joysticks
        /////////////////////////////////////////////////////
        JoystickList = guienv->addComboBox (core::recti( 0,0,200,30),
                                0,  //!< parent
                                JOYSTICK_LIST  //!< Id
                                );


        // Should be
        GlobalDeadzoneText = guienv->addStaticText ( L"Deadzones value" , recti(200, 0, 300, 20),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  THRESHOLD_TEXT,   //!< Id
                                                  false //!<fillBackground
                                                  );

        GlobalDeadzoneSelector = guienv->addScrollBar ( true,    //!< horizontal
                                               core::recti ( 300, 0,450,20),
                                               0,    //!< parent
                                               DEADZONE_SELECTOR       //!< Id
                                               );
        GlobalDeadzoneSelector->setMax ( SCROLLBAR_MAXVALUE );


        ThresholdText = guienv->addStaticText ( L"Threshold value" , recti(200, 20, 300, 40),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  THRESHOLD_TEXT,   //!< Id
                                                  false //!<fillBackground
                                                  );

        ThresholdSelector = guienv->addScrollBar ( true,    //!< horizontal
                                               core::recti ( 300, 20, 450, 40),
                                               0,    //!< parent
                                               THRESHOLD_SELECTOR       //!< Id
                                               );
        ThresholdSelector->setMax ( SCROLLBAR_MAXVALUE );



        JoystickDescriptor = guienv->addStaticText ( L"Number of buttons: " , recti(5, 180, 200, 200),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  JOYSTICKDESCRIPTOR_TEXT,   //!< Id
                                                  false //!<fillBackground
                                                  );

        /////////////////////////////////////////////////////
        ///// Create  listbox to log events
        /////////////////////////////////////////////////////
        //EventList = guienv->addListBox(rect<s32>(50, 140, 250, 210));

        //addStaticText (const wchar_t *text, const core::rect< s32 > &rectangle, bool border=false, bool wordWrap=true, IGUIElement *parent=0, s32 id=-1, bool fillBackground=false)
        stringw desc(L"This joystick supports ");
        desc += L"0";
        desc += L" buttons";
        CapabilitiesText = guienv->addStaticText (desc.c_str() , recti(),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  -1,   //!< Id
                                                  false //!<fillBackground
                                                  );





        /////////////////////////////////////////////////////
        ///// Create Table for buttons
        /////////////////////////////////////////////////////
//        IGUITable *  addTable (const core::rect< s32 > &rectangle, IGUIElement *parent=0, s32 id=-1, bool drawBackground=false)=0
        AxesTable = guienv->addTable(
                         core::recti(200,200,400,400),
                         0,      //!< Parent
                         AXES_TABLE //!< Ids
                         );

        AxesTable->addColumn(L"Axes");
        AxesTable->addColumn(L"Values");
        AxesTable->addColumn(L"Deadzone");
        //AxesTable->addColumn(L"Threshold");

        #define ADD_ROW(axis)  AxesTable->addRow(EJA_AXIS_##axis); \
                                AxesTable->setCellText(EJA_AXIS_##axis,0,L###axis); \
                              AxesTable->setCellText(EJA_AXIS_##axis,1,L"0"); \
                              AxesTable->setCellText(EJA_AXIS_##axis,2,L"0");

        // Row,Column
        ADD_ROW(X);
        ADD_ROW(Y);
        ADD_ROW(Z);
        ADD_ROW(R);
        ADD_ROW(U);
        ADD_ROW(V);
//        ADD_ROW(POVX);
//        ADD_ROW(POVY);
//        ADD_ROW(POV);

        #undef ADD_ROW

        AxesTable->addRow(POV_ROW);
        AxesTable->setCellText(POV_ROW,0,L"PovHat");
        AxesTable->setCellText(POV_ROW,1,L"0");

//        core::recti pos(0,0,200,30);

//        guienv->addStaticText( L"X axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
//        guienv->addStaticText( L"Y axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
//        guienv->addStaticText( L"Z axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
    };






    bool activateJoysticks(){

        IInputManager *input = Device->getInputManager();

        core::array<IJoystick*> temp;
        //joysticks
        if(input &&  input->activateJoysticks( temp ) ){

            Logger->log("Joystick activation ok");

            //
            for(u32 i(0),last(temp.size()); i < last; ++i){
                onJoystickDetection( temp[i] );
            }
        }

        //! No joystick found
        if( Joysticks.empty() ){
            return false;
        }

        //CurrentJoystick = input->getJoystick( joysticks[0] );

        return true;
    }




    /**

    **/
    bool changeJoystick(IJoystick* joy){


        //IJoystick* joy = Device->getInputManager()->getJoystick( newId );

        if(!joy){
            Logger->log("Could not set new joystick: null pointer",ELL_WARNING);
            return false;
            // will update number of buttons and axis

        }

        CurrentJoystick = joy;

        //! TODO display description of joystick
        core::stringc desc("Joystick description:\n");
        desc += "Buttons:";
        desc += CurrentJoystick->getButtonCount();
        desc += "\n";
        desc += "Axes:";
        desc += CurrentJoystick->getButtonCount();
        desc += " With name \n";

        Logger->log( desc.c_str(), ELL_INFORMATION );
        Logger->log( CurrentJoystick->getName().c_str(), ELL_INFORMATION );

        // update axes table

        JoystickDescriptor->setText(L"Joystick description");

        //const SJoystickCapabilities& capabilities = joy->getCapabilities();
        for(u16 iAxis(0); iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

            EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>( iAxis);

            stringw value = "unsupported";
            // if axis supported by joystick
            if( joy->hasAxis( eAxis ) )
            {

                value = "supported";
                value += joy->getAxisValue(eAxis);
            }


            AxesTable->setCellText( eAxis,1,value.c_str() );
        }

        return true;
    }





    void updateAxesTable() {

//        if(!CurrentJoystick)
//            return;


            // Display Axis value
        //const SJoystickCapabilities& capabilities = CurrentJoystick->getCapabilities();
        for(u16 iAxis(0); iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

            EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>( iAxis);

            stringw value = "unsupported";
            // if axis supported by joystick
            if( CurrentJoystick->hasAxis( eAxis ) )
            {

                //value = "OK";
                value = "";
                value += CurrentJoystick->getAxisValue(eAxis);
            }


            AxesTable->setCellText( eAxis,1,value.c_str() );
            value = "";

            value += CurrentJoystick->getDeadZone(eAxis);

            //std::cout << "Deadzone value" << CurrentJoystick->getDeadZone(eAxis);

            AxesTable->setCellText( eAxis, 2, value.c_str() );
        }

        // Update POV value
        stringw value = "unsupported";
        if( CurrentJoystick->hasPovHat() )
            {

                //value = "OK";
                value = "";//getAxisValue(eAxis)
                switch (CurrentJoystick->getState().PovHat)
                {
                    case EJP_CENTERED:      value = "Centered";break;
                    case EJP_NORTH:         value = "North";break;
                    case EJP_NORTH_WEST:    value = "North West";break;
                    case EJP_NORTH_EAST:    value = "North East";break;
                    case EJP_EAST:          value = "East";break;
                    case EJP_SOUTH:         value = "South";break;
                    case EJP_SOUTH_WEST:    value = "South west";break;
                    case EJP_SOUTH_EAST:    value = "South east";break;
                    case EJP_WEST:          value = "West";break;
                    //case EJP_NORTH:     value = "North";break;

                    default:
                        value = "unknown";
                        break;
                }
                //( CurrentJoystick->PovHat) value += ;
            }

        AxesTable->setCellText( POV_ROW,1, value.c_str() );
    }


    void onJoystickDetection( IJoystick* joystick)
    {
        //insert
        //set .begin(), joystick->getName().end()
        core::stringw joyName( joystick->getName() );

        u32 id = JoystickList->addItem( joyName.c_str(), Joysticks.size() );

        Joysticks.set(  joystick , id );
        //Joysticks.push_back( joystick);


        changeJoystick( joystick );
    }



    void onJoystickUnplug( IJoystick* joystick)
    {
        //insert
        //set



        TJoystickMap::Node* node = Joysticks.find( joystick );

        if(  node == 0 ){
            Logger->log("Trying to unplug an unregistered joystick", ELL_ERROR);
            return;
        }

        Logger->log("Unplugging joystick", ELL_ERROR);

        //u32 id = Joysticks[joystick];
        const u32 id = node->getValue();

        JoystickList->removeItem( id );
        Joysticks.remove ( joystick);

        // If
        if(CurrentJoystick == joystick){

            if(Joysticks.empty()){
                CurrentJoystick = 0;
            }
            else {
                CurrentJoystick = Joysticks.getRoot()->getKey();
            }
        }
        else {

            // Nothing to do
        }
    }



// Grabber/drop
    bool OnEvent(const SEvent& event){


        stringc logString;
        IJoystick* joystick = 0;

        switch ( event.EventType )
        {

            /////////////////////////////////////////////////////
            ///// Deal with joystick events
            /////////////////////////////////////////////////////
            case EET_JOYSTICK_INPUT_EVENT:

                joystick = event.JoystickEvent.Joystick;

                switch(event.JoystickEvent.Type)
                {

                    case EJE_PLUGGED:

                        logString = "Joystick";
                        logString += joystick->getName();
                        logString  += " plugged";

                        onJoystickDetection( joystick );
                        break;


                    case EJE_UNPLUGGED:
                        logString = "unplug event ";
                        onJoystickUnplug( joystick );
                        break;

                    case EJE_BUTTON_PRESSED:
                        logString = "Button ";
                        logString += event.JoystickEvent.Button;
                        logString += " pressed";
                        break;

                    case EJE_BUTTON_RELEASED:
                        logString = "Button ";
                        logString += event.JoystickEvent.Button;
                        logString += " released";
                        break;

                    case EJE_POV_MOVED:
                        logString = "Pov moved. New value:";
                        logString += joystick->getState().PovHat;
                        break;

                    case EJE_AXIS_MOVED:
                        logString = "Axis ";
                        logString += event.JoystickEvent.MovedAxis;
                        logString += " moved. New value: ";
                        logString += joystick->getState().getAxisValue(event.JoystickEvent.MovedAxis);

                        AxesTable->setCellText( event.JoystickEvent.MovedAxis,
                                               1,
                                               L"temp"
                                            );
                        break;

                    default:
                        break;

                };
                break;

            case EET_GUI_EVENT:
                //IGUIElement* caller

                switch (event.GUIEvent.EventType)
                {
                    // Threshold changes
                    case EGET_SCROLL_BAR_CHANGED :
                        {
                            // Selon l'id


                            IGUIScrollBar* bar = static_cast<IGUIScrollBar*>( event.GUIEvent.Caller);

                            //s32 value = bar->getPos();
                            f32 correctedValue = static_cast<f32>( bar->getPos() )/static_cast<f32>(SCROLLBAR_MAXVALUE);

                            if( bar->getID() == THRESHOLD_SELECTOR)
                            {
                                logString = "New threshold value ";
                                logString += correctedValue;

                                //GlobalDeadzoneSelector


                                if(CurrentJoystick){

                                    CurrentJoystick->setThreshold( correctedValue );

                                    stringw desc(L"Threshold value: ");
                                    desc += CurrentJoystick->getThreshold();



                                    ThresholdText->setText( desc.c_str() );
                                }

                            }
                            //
                            //DEADZONE_SELECTOR
                            else
                            {
                                logString = "New deadzone value: ";
                                logString += correctedValue;

                                if(CurrentJoystick){

                                    for(u16 iAxis(0); iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

                                        EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>( iAxis);
                                        //f32 deadzone = static_cast<f32>(value) / SCROLLBAR_MAXVALUE;

                                        CurrentJoystick->setDeadZone(eAxis, correctedValue);
                                    }
                                }
                            }

                        }
                        break;

                    /// The selection in a combo box has been changed.
                    case EGET_COMBO_BOX_CHANGED:
                        {


                        logString = "New joystick selected";
                        // TODO getId
                        //static_cast<IGUIComboBox>
                        s32 id = JoystickList->getSelected () ;
                        if(id == -1){
                            Logger->log("Error",ELL_ERROR);
                        }
                        else {

                            // go through list and set good joystick
                            TJoystickMap::Iterator itr = Joysticks.getIterator();

                            while(!itr.atEnd())
                            {
                                TJoystickMap::Node* n = itr.getNode();
                                u32 result = n->getValue();
                                if(static_cast<s32>(result) == id)
                                {
                                    changeJoystick( n->getKey() );
                                    break;
                                }

                                itr++;
                            }
                        }
                        //Joysticks.find()

                        }
                        break;

                    default:
                        break;
                }


            default:
                break;
        };

        if( logString.size() >0 ){
        //logger->addItem()
//            logString.append("\n");
            Logger->log( logString.c_str() , ELL_INFORMATION);
            return true;    //!< Absorb event
        }
        return false;

    };


};



/*
This is the main method. We can now use main() on every platform.
*/
int main()
{

	IrrlichtDevice *device = createDevice( video::EDT_SOFTWARE, dimension2d<u32>(640, 480), 16,
                                    false, false, false, 0);

	if (!device)
		return 1;

	device->setWindowCaption(L"Hello World! - Improved Input Demo");




	IVideoDriver* driver        = device->getVideoDriver();
	ISceneManager* smgr         = device->getSceneManager();
	IGUIEnvironment* guienv     = device->getGUIEnvironment();
	IInputManager* input        = device->getInputManager();
    ILogger* logger             = device->getLogger();



    MyEventReciever myReceiver( device );
    device->setEventReceiver( &myReceiver );


	smgr->addCameraSceneNode(0, vector3df(0,30,-40), vector3df(0,5,0));



    if( !myReceiver.activateJoysticks() ){

        logger->log("No joystick could be retrieved",ELL_WARNING);
        //device->closeDevice();
        //return 0;
    }



    ITexture* greenButton = driver->getTexture("green_button.png");
    ITexture* redButton = driver->getTexture("red_button.png");

    IJoystick* lastFrameJoystick = myReceiver.CurrentJoystick;
//    IJoystick* joystick0 =  myReceiver.CurrentJoystick;

    //! Main loop
	while(device->run())
	{
        IJoystick* joystick0 =  myReceiver.CurrentJoystick;
        if(joystick0 != lastFrameJoystick)
        {

            if(joystick0 == 0)
            {
                logger->log("No joystick retrieved",ELL_INFORMATION);
            }
            else
            {
                logger->log("At least one joystick retrieved");
            }

        }
        else {
            // Nthg to do
        }


        lastFrameJoystick = joystick0;


        core::position2di destPos(10,200);
        ITexture* currentTexture = 0;

        //draw2DImage (const video::ITexture *texture, const core::position2d< s32 > &destPos)=0

		driver->beginScene(true, true, SColor(255,100,101,140));

        //! draws gui first
		smgr->drawAll();
		guienv->drawAll();

        //! Then custom drawings
        if(joystick0)
        {

            myReceiver.updateAxesTable();

            for(u16 i(0);i < joystick0->getButtonCount(); ++i){

                if( joystick0->getState().isButtonPressed(i) )
                {
                    currentTexture = greenButton;
                }
                else
                {
                    currentTexture = redButton;
                }

                driver->draw2DImage ( currentTexture, destPos);
                //destPos.X += 20;
                destPos.Y += currentTexture->getSize().Height;
            }


        }


		driver->endScene();
	}

	device->drop();

	return 0;
}

/*
That's it. Compile and run.
**/
